function optimalpath=ViterNLLength(trainData,Nfreq,Lfreq,transitionN,transitionL,piN,piL,PLd,PLt,PNt,N,L);
T=length(trainData);
%forward algorithm
trainData2=fliplr(5-trainData);
%L must be equal to length(PLd);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%viterbi
%obtain FN(t) FL(t)
%1. initialize for t=1
%N=truncation allowed for nucleosome. PNt is of length 148 only
%the 148-N elements are non-zero
%L=length(PLt) the length of extra bp in either end of sequences
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

FN(1)=piN*PNt(1)*calTran(trainData(1),147-1+1,transitionN,Nfreq)*calTran(trainData2(T),1,transitionN,Nfreq);
FL(1)=(piL*PLt(1)*Lfreq(trainData(1)))*Lfreq(trainData2(T));
fc(1)=FN(1)+FL(1);
Ssum(1)=FL(1)+FN(1);
Llength=length(PLd);

transPosL(1)=0;
transStatL(1)=0;
transPosN(1)=0;
transStatN(1)=0;

%2. Recursion with a scale coefficient Assume L<147
%%calculate alphaL(t) and alphaN(t) for t=2:T-1
for t=2:L
    FN(t)=piN*PNt(t)*calTran(trainData(1:t),147-t+1,transitionN,Nfreq)*calTran(trainData2(T-t+1:T),1,transitionN,Nfreq);
    transPosN(1)=0;
    transStatN(1)=0;

    for d=1:t-1
        L00vect(d)=FN(t-d)*PLd(d)*calTranL(trainData(t-d+1:t),transitionL,Lfreq)*calTranL(trainData2(T-t+1:T-t+d),transitionL,Lfreq);
    end
    [FLvalue maxTranL2]=max(L00vect);
    FLzero=piL*PLt(t)*calTranL(trainData(1:t),transitionL,Lfreq)*calTranL(trainData2(T-t+1:T),transitionL, Lfreq);
    if (FN(t)+FLvalue+FLzero)==0
        Ssum(t)=Ssum(t-1)/16;
        fc(t)= Ssum(t)/Ssum(t-1);
        transPosL(t)=t-1;
        transStatL(t)=2;
        transPosN(t)=t-1;
        transStatN(t)=1;
    else
        if(FLvalue<FLzero)
            FL(t)=FLzero;
            transPosL(t)=0;
            transStatL(t)=0;
        end
        if (FLvalue>=FLzero)
            FL(t)=FLvalue;
            transPosL(t)=t-maxTranL2(1);
            transStatL(t)=1;
        end
        Ssum(t)=(FN(t)+FL(t));
        fc(t)= Ssum(t)/Ssum(t-1);
    end
end

for t=L+1:147
    FN(t)=piN*PNt(t)*calTran(trainData(1:t),147-t+1,transitionN,Nfreq)*calTran(trainData2(T-t+1:T),1,transitionN,Nfreq);
    for d=1:min((t-1),Llength)
        L00vect(d)=FN(t-d)*PLd(d)*calTranL(trainData(t-d+1:t),transitionL,Lfreq)*calTranL(trainData2(T-t+1:T-t+d),transitionL,Lfreq);
    end
    [FLvalue maxTranL2]=max(L00vect);
    FL(t)=FLvalue;
    if (FN(t)+FL(t))==0
        Ssum(t)=Ssum(t-1)/16;
        fc(t)= Ssum(t)/Ssum(t-1);
        pathN(t)=(t-1)*10;
        pathL(t)=11;
    else
        Ssum(t)=(FN(t)+FL(t));
        fc(t)= Ssum(t)/Ssum(t-1);
        transPosL(t)=t-maxTranL2;
        transStatL(t)=1;
        transPosN(t)=0;
        transStatN(t)=0;
    end
end

for t=1:147
    hFN(t)=FN(t)/prod(fc(1:t));
    hFL(t)=FL(t)/prod(fc(1:t));
end


tol=147;

for t=148:T-1
    Nseq=trainData(t-(147-1):t);
    Nseq2=trainData2(T-t+1:(T-t+147));
    FN(t)=hFL(t-147)*calTran(Nseq,1,transitionN,Nfreq)*calTran(Nseq2,1,transitionN,Nfreq)*prod(fc(t-tol:t-147));
    for d=1:Llength
        L11vec(d)=hFN(t-d)*PLd(d)*calTranL(trainData(t-d+1:t),transitionL,Lfreq)*calTranL(trainData2(T-t+1:T-t+d),transitionL,Lfreq)*prod(fc(t-tol:t-d));
    end

    [FLvalue maxTranL3]=max(L11vec);
    FL(t)=FLvalue;
    if FL(t)+FN(t)==0
        Ssum(t)=Ssum(t-1)/16;
        fc(t)= Ssum(t)/Ssum(t-1);
        hFN(t)=0;
        hFL(t)=0;
        transPosL(t)=t-1;
        transStatL(t)=2;
        transPosN(t)=t-1;
        transStatN(t)=1;
    else
        transPosL(t)=t-maxTranL3;
        transStatL(t)=1;
        transPosN(t)=t-147;
        transStatN(t)=2;
        hFN(t)=FN(t)/(FN(t)+FL(t));
        hFL(t)=FL(t)/(FN(t)+FL(t));
        Ssum(t)=FL(t)+FN(t);
        fc(t)=((FN(t)+FL(t))/prod(fc(t-tol:t-1)));
    end
end

%3. Termination for t=T
%%obtain FT(N)
for d=1:147
    NseqT=trainData(T-d+1:T);
    NseqT2=trainData2(1:d);
    ccvec=fc(T-tol:T-d);
    NTvec(d)=PNt(d)*hFL(T-d)*calTran(NseqT,1,transitionN,Nfreq) *calTran(NseqT2,147-length(NseqT2)+1,transitionN,Nfreq)*prod(ccvec);
end
[FNvalue maxTran]=max(NTvec);
FN(T)=FNvalue;
maxTran=T-maxTran;
transPosN(T)=maxTran;
transStatN(T)=2;

for d=1:L
    LseqT=trainData(T-d+1:T);
    LseqT2=trainData2(1:T-(T-d+1)+1);
    ccvec=fc(T-tol:T-d);
    LTvec(d)=hFN(T-d)*PLt(d)* calTranL(LseqT, transitionL, Lfreq)* calTranL(LseqT2, transitionL, Lfreq)*prod(ccvec);
end
[FLvalue maxTran]=max(LTvec);
maxTran=T-maxTran;
FL(T)=FLvalue;
transPosL(T)=maxTran;
transStatL(T)=1;

hFN(T)=FN(T)/(FN(T)+FL(T));
hFL(T)=FL(T)/(FN(T)+FL(T));

fc(T)=((FN(T)+FL(T))/prod(fc(T-tol:T-100)))*(1/prod(fc(T-99:T-1)));
%end

%%posteriord decoding

optimalpath=zeros(T,1)-2;
optimalpath=zeros(T,1)-2;
if hFN(T)<hFL(T)
    optimalpath(T)=0;
    optimalpath(transPosL(T)+1:T)=0;
    pos=transPosL(T);
    state=transStatL(T);
end

if hFN(T)>hFL(T)&&hFN(T)>hFL(T)
    optimalpath(T)=1;
    optimalpath(transPosN(T)+1:T)=1;
    pos=transPosN(T);
    state=transStatN(T);
end

stopseq=1;
while stopseq==1
    if(state==1)
        state=transStatN(pos);
        newpos=transPosN(pos);
        optimalpath(newpos+1:pos)=1;
        pos=newpos;
    else
        state=transStatL(pos);
        newpos=transPosL(pos);
        optimalpath(newpos+1:pos)=0;
        pos=newpos;
    end
    if(pos==0)
        stopseq=0;
    end
end


end
